/* 
officiel 01/12/17
ecrit pour la wilulu  www.arpschuino.fr/wilulu.php
gradation pwm sur un canal
fonctionne avec "emeteur_arpschuino_officiel" ou "emeteur_JLink_DMX" comme emmeteur
adresse = adreesse de l'emeteur + valeur définie par l'encodeur rotatif
En l'absence de signal, la led reste allumé, elle clignote lorsqu'elle recoit

reprise 07/08/18
mise en veille si tension trop basse
band frequency et frequency fine pour comptabilité avec l'arptefact::tanceiver
identifiant offset

official 01/12/17
Written for the wilulu  www.arpschuino.fr/wilulu_e.php
one channel dimmer
work with "emeteur_arpschuino_officiel" or "emeteur_JLink_bridge_arp" as emiter
address = emiter address + value set by the rotary encoder
If there is no signal, the LED remains lit, flashes when it is received

reprise 07/08/18
mise en veille si tension trop basse
band frequency et frequency fine pour comptabilité avec l'arptefact::tanceiver
identifiant offset

pour programmer la wilulu :
http://localhost/programmer-un-arpsensors-wilulu.php
to program the wilulu :
http://localhost/programmer-un-arpsensors-wilulu_e.php
*/

#include <Arpschuino.h>
#include <ArpRFLib.h>
#include <avr/sleep.h>

#define NODEID  4  //Adresse RF 
#define NETWORKID  212  //adresse du reseau commune à toute les machine

/////////////////////////////  frequency  ////////////////////////////////////////////
//#define band RF12_868MHZ //(Europe, Afrique, moyen-orient...)
//float frequency_setting = 868.00 ;//beetween 863.00 > 870.00
#define band RF12_915MHZ //(America, australia, China and eastern Pacific Islands...)
float frequency_setting = 924.00 ;//902–924 MHz

//#define band RF12_433MHZ//non teste-not tested
//float frequency_setting = 433.50 ;//433,05-434.79 presque partout mais beaucoup utilisé. Necessite une antenne spécifique
//////////////////////////////////////////////////////////////////////////////////////////


uint8_t dip[4]={WiluluAdress0,WiluluAdress1,WiluluAdress2,WiluluAdress3};//
uint8_t identifiant=0;
//////////////////////////////////////////////////////////////////////////////////////
#define identifiant_offset 0   //for more than 16 wilulu !
/////////////////////////////////////////////////////////////////////////////////////

uint32_t previousMillis = 0;
#define interval 1000

void setup() {

    pinMode(LED_BUILTIN,OUTPUT);
    digitalWrite(LED_BUILTIN, HIGH);//led allumée en l'abscence de signal

    for (int i =0;i<4;i++)
    {
      pinMode(dip[i],INPUT);
      digitalWrite(dip[i],HIGH);
    }
    pinMode (WiluluOUT , OUTPUT);

    delay (100);//A diminuer ??????????????
    rf12_initialize(NODEID, band, NETWORKID,calcul_freq(frequency_setting));

    for(int i=0;i<4;i++)
    {
       if(!digitalRead(dip[i]))
       {
        identifiant += 1<<(i);
       }
    }   
    identifiant+=identifiant_offset; //

////////////////////energy saving//////////////////////////////////////////
    for (int i =0;i<4;i++)
    {
      digitalWrite(dip[i],LOW);  //desactivation des pullup
    }
    ADCSRA &= ~(1<<ADEN);                     //turn off ADC
    ACSR |= _BV(ACD);                         //disable the analog comparator
    MCUCR |= _BV(BODS) | _BV(BODSE);          //turn off the brown-out detector
  ////////////////////battery protection//////////////////////////////////////////
  
    //rf12_control(0xC045);//set RF12 Low Battery Detect to 2.7V
    //rf12_control(0xC046);//set RF12 Low Battery Detect to 2.8V
    rf12_control(0xC047);//set RF12 Low Battery Detect to 2.9V
    //rf12_control(0xC048);//set RF12 Low Battery Detect to 3V
    //rf12_control(0xC049);//set RF12 Low Battery Detect to 3.1V
}

void loop() {
     if (rf12_lowbat())  sleep();   

     if (rf12_recvDone() && rf12_crc == 0) 
     {
        led_temoin ();
        analogWrite (WiluluOUT , rf12_data[identifiant]);
     }
     else
     {
        uint32_t currentMillis = millis();
       
        if(currentMillis - previousMillis >= interval) {
          // une seconde sans reception
          previousMillis = currentMillis;   
          digitalWrite(LED_BUILTIN,  HIGH);      
         }
     }
}

uint16_t calcul_freq (float freq_set)
{
  if(band == RF12_868MHZ)
  {
    freq_set= freq_set*100-86000;
    freq_set=freq_set*2;
  }
  else if(band == RF12_915MHZ)
  {
    freq_set= freq_set-900;
    freq_set=freq_set/0.0075;
  }
  else if(band == RF12_433MHZ)
  {
    freq_set= freq_set-430;
    freq_set=freq_set*400;
  }  
  return freq_set;
}

void sleep() {
  cli();
  analogWrite (WiluluOUT ,0);          //extinction de la led "out"
  rf12_sleep(0);                      // no wakeup
  set_sleep_mode(SLEEP_MODE_PWR_DOWN); // do a complete power-down
  sleep_enable();                      // enable sleep mode
  sleep_mode();
  //sei();                               // allow interrupts to end sleep mode                                    
  sleep_cpu();                         // go to sleep
  //sleep_disable();                     // disable sleep mode for safety
}

//  LowPower.powerDown(SLEEP_FOREVER, ADC_OFF, BOD_OFF);
